   /* global bootbox */

   function segundaCarga() {
      datosTipoUsuario.listarTipoUsuario();
      soloLetras('txtTipoDeUsuario');
      editarTipoUsuario();
      desactivarTipoUsuario();
      activarTipoUsuario();
      submitKey('formTipoUsuario', '#btnBuscar');
   }

   var datosTipoUsuario = {listarTipoUsuario: function () {
         var filtro = $('#txtTipoDeUsuario').val();
         var json = {
            "filtro": filtro
         };
         $("#tblTipoUsuario").DataTable({
            "language": {
               "lengthMenu": "Mostrar: _MENU_",
               "zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
               "info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ Tipos de Usuarios",
               "infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
               "search": "Filtrar:",
               "loadingRecords": "Cargando...",
               "processing": '<span style="width:100%;"><img src="http://www.snacklocal.com/images/ajaxload.gif"></span>',
               "scrollY": false,
               "paginate": {
                  "first": "First",
                  "last": "Last",
                  "next": "Siguiente",
                  "previous": "Anterior"
               }
            },
            dom: '<"datatable-scroll"t>r<"datatable-footers"ip>',
            "ajax": {
               type: 'POST',
               "url": '../servlet/TipoUsuarioServlet?accion=listarTipoUsuario',
               data: json
            },
            "bSort": false,
            "bFilter": false,
            "serverSide": true,
            "processing": true,
            "aaSorting": [],
            "ordering": false,
            "bLengthChange": false,
            "bInfo": true,
            "paging": true,
            "iDisplayLength": 15,
            "columnDefs": [
               {targets: 0, orderable: false, width: "7%", className: "text-center"},
               {targets: 1, orderable: false, width: "20%"},
               {targets: 2, orderable: false, width: "10%", className: "text-center"},
               {targets: 3, orderable: false, width: "7%", className: "text-center"}
            ],
            "columns": [
               {"data": "numeral"},
               {"data": "nombreTipoUsuario"},
               {"data": "estadoTipoUsuario",
                  render: function (data, type, row) {
                     var retorno;
                     if (data === 0) {
                        retorno = "<span class='label label-danger' style='color: white'>INACTIVO</span>";
                     } else if (data === 1) {
                        retorno = '<span class="label label-success" style="color: white">ACTIVO</span>';
                     }
                     return retorno;
                  }
               },
               {"data": "estadoTipoUsuario", "render": function (data, type, row) {
                     let retorno = ``;
                     retorno = ` 
                                            <span data-toggle="tooltip" title="Editar" style="cursor: pointer"> <i class='editar click${row.numeral} glyphicon glyphicon-pencil text-blue-800'></i> &nbsp;&nbsp;&nbsp; </span>`;
                     if (data === 1) {
                        retorno += `
                                            <span data-toggle="tooltip" title="Desactivar" style="cursor: pointer"> <i class='desactivar icon-user-block text-danger-800'></i> </span>`;
                     } else {
                        retorno += `
                                            <span data-toggle="tooltip" title="Activar" style="cursor: pointer"> <i class='activar icon-user-check text-success-800'></i> </span>`;
                     }
                     return retorno;
                  }

               }
            ]

         });
      }
   };

   let flagBusqueda = false;
   $('#tblTipoUsuario').on('draw.dt', function () {
      $('[data-toggle="tooltip"]').tooltip();
   });

   function recargar() {
      $("#tblTipoUsuario").DataTable().destroy();
      datosTipoUsuario.listarTipoUsuario();
   }

   function refrescar() {
      $("#tblTipoUsuario").DataTable().ajax.reload(null, false)
   }

   var validar = 0;
   $('#btnBuscar').click(function () {
      validar = $('#formTipoUsuario').validate({
         rules: {
            txtBusqueda:
                    {required: true}
         },
         messages: {
            txtBusqueda:
                    {required: "<b>&times; Ingrese una Búsqueda</b>"}
         }
      });
      if (validar.form()) {
         recargar();
      }
   });

   $('#btnLimpiar').click(function () {
      $('#txtTipoDeUsuario').val("");
      if (validar !== 0) {
         validar.resetForm();
      }
      recargar();
   });

   function validCaracForm() {
      new Input({el: '#editarNombre', param: 'alphanumeric'}).validate();
   }

   function editarTipoUsuario() {
      $('#tblTipoUsuario tbody').on('click', '.editar', function () {
         var table = $("#tblTipoUsuario").DataTable();
         var data = table.row($(this).parents('tr')).data();
         var codigo = data["codigoTipoUsuario"];
         var campo = data["nombreTipoUsuario"];
         var numeral = data["numeral"];
         validarTipoUsuario(codigo)
                 .then((data) => {
                    if (data === 0) {
                       var editarTipoUsuario = bootbox.dialog({
                          title: "<span><i class='ace-icon fa fa-tags'></i> EDITAR TIPO DE USUARIO</span>",
                          headerClass: "modal-bg-primary",
                          size: "small",
                          message: `<form id="formEditarTipoUsuario" onsubmit="return false" autocomplete="off">
                                    <div class='col-md-12'>
                                        <div class="form-group">
                                            <label style="font-size: small">
                                                Nombre: 
                                            </label>
                                            <span id="spanAterik" class="text-danger"> (*)</span>
                                            <input type="text" id="editarNombre" name="txtBusqueda" class="form-control" value="${campo}" placeholder="INGRESE NOMBRE DEL TIPO DE USUARIO" style="text-transform:uppercase;">
                                            <br>
                                            <div class="text-right" style="font-size: small"> 
                                                <span class="text-danger">(*) </span>  Campo obligatorio
                                            </div>
                                        </div>
                                    </div> 
                                </form>`,
                          buttons: {
                             si: {
                                label: "<i class='fa fa-check bigger-110'></i>&nbsp; Editar",
                                className: "btn bg-primary border-primary-600 btn-xs buttonOk",
                                callback: function () {
                                   var nombre = $('#editarNombre').val();
                                   var mayuscula = nombre.toUpperCase();
                                   var json = {
                                      "nombre": mayuscula,
                                      "codigo": codigo
                                   };
                                   var validar = $("#formEditarTipoUsuario").validate({
                                      rules: {
                                         txtBusqueda:
                                                 {required: true}
                                      },
                                      messages: {
                                         txtBusqueda:
                                                 {required: "<b>&times; Seleccione una Búsqueda</b>"}
                                      }
                                   });
                                   if (validar.form()) {
                                      validarNombreTipoUsuario(mayuscula, campo, 1)
                                              .then((data) => {
                                                 if (data === 0) {
                                                    bootbox.dialog({
                                                       className: "dialogExtraSmall",
                                                       headerClass: "modal-bg-primary",
                                                       title: "<i class='ace-icon fa fa-check-circle white'></i> <span class='white'>Conformidad</span>",
                                                       message: "¿Está seguro de editar este tipo de Usuario?",
                                                       buttons: {
                                                          si: {
                                                             label: "<i class='fa fa-check bigger-110'></i>&nbsp; Si",
                                                             className: "btn-primary",
                                                             callback: function () {
                                                                $.ajax({
                                                                   type: 'POST',
                                                                   url: "../servlet/TipoUsuarioServlet?accion=editarTipoUsuario",
                                                                   dataType: 'JSON',
                                                                   data: json,
                                                                   success: function (data) {
                                                                      if (data === 1) {
                                                                         bootbox.dialog({
                                                                            className: "dialogExtraSmall",
                                                                            title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
                                                                            headerClass: "modal-bg-success",
                                                                            message: "Tipo de Usuario correctamente modificado",
                                                                            buttons: {
                                                                               si: {
                                                                                  label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                                                                  className: "btn-success",
                                                                                  callback: function () {
                                                                                     refrescar();
                                                                                  }
                                                                               }
                                                                            }
                                                                         });
                                                                      } else {
                                                                         bootbox.dialog({
                                                                            title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                                                                            headerClass: "modal-bg-warning",
                                                                            message: "Ha ocurrido un error",
                                                                            buttons: {
                                                                               si: {
                                                                                  label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                                                                  className: "btn-warning",
                                                                                  callback: function () {
                                                                                     refrescar();
                                                                                  }
                                                                               }
                                                                            }
                                                                         });
                                                                      }
                                                                   }
                                                                });
                                                             }
                                                          }, no: {
                                                             label: "<i class='fa fa-times bigger-110'></i>&nbsp; No",
                                                             className: "btn-danger",
                                                             callback: function () {
                                                                $(`#tblTipoUsuario tbody .click${numeral}`).click();
                                                             }
                                                          }
                                                       }
                                                    });
                                                 } else {
                                                    bootbox.dialog({
                                                       className: "dialogExtraSmall",
                                                       title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                                                       headerClass: "modal-bg-warning",
                                                       message: "¡El nombre ingresado está en uso!",
                                                       buttons: {
                                                          si: {
                                                             label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                                             className: "btn-warning",
                                                             callback: function () {
                                                                $(`#tblTipoUsuario tbody .click${numeral}`).click();
                                                             }
                                                          }
                                                       }
                                                    });
                                                 }
                                              });

                                   } else {
                                      return false;
                                   }

                                }

                             },
                             no: {
                                label: "<i class='fa fa-times bigger-110'></i>&nbsp; Cancelar",
                                className: "btn bg-danger border-danger-600 btn-xs",
                                callback: function () {
                                }
                             }
                          }
                       });
                       editarTipoUsuario.init(function () {
                          validCaracForm();
                          submitKey('formEditarTipoUsuario', '.buttonOk');
                       });
                    } else {
                       bootbox.dialog({
                          className: "dialogExtraSmall",
                          title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                          headerClass: "modal-bg-warning",
                          message: "El tipo de usuario seleccionado está en uso",
                          buttons: {
                             si: {
                                label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                className: "btn-warning",
                                callback: function () {
                                }
                             }
                          }
                       });
                    }
                 });
      });
   }

   $('#btnNuevoTipoUsuario').on('click', function () {
      var nuevoTipoUsuario = bootbox.dialog({
         title: "<span><i class='ace-icon fa fa-tags'></i> CREAR TIPO DE USUARIO</span>",
         headerClass: "modal-bg-primary",
         size: "small",
         message: `<form id="formCrearTipoUsuario" onsubmit="return false" autocomplete="off">
                                    <div class='col-md-12'>
                                        <div class="form-group">
                                            <label style="font-size: small">
                                                Nombre: 
                                            </label>
                                            <span id="spanAterik" class="asterisk"> (*)</span>
                                            <input type="text" id="crearNombre" name="txtBusqueda" class="form-control" value="" placeholder="INGRESE NOMBRE DEL TIPO DE USUARIO" style="text-transform:uppercase;">
                                            <br>
                                            <div class="text-right" style="font-size: small"> 
                                                <span class="text-danger">(*) </span>  Campo obligatorio
                                            </div>
                                        </div>
                                    </div> 
                                </form>`,
         buttons: {
            confirm: {
               label: "<i class='fa fa-check bigger-110'></i>&nbsp; Crear",
               className: "btn-primary buttonOk",
               callback: function () {
                  var nombre = $('#crearNombre').val();
                  var mayuscula = nombre.toUpperCase();
                  var json = {
                     "nombre": mayuscula
                  };
                  var validar = $("#formCrearTipoUsuario").validate({
                     rules: {
                        txtBusqueda:
                                {required: true}
                     },
                     messages: {
                        txtBusqueda:
                                {required: "<b>&times; Seleccione una Búsqueda</b>"}
                     }
                  });
                  if (validar.form()) {
                     validarNombreTipoUsuario(mayuscula, '', 0)
                             .then((data) => {
                                if (data === 0) {
                                   $.ajax({
                                      type: 'POST',
                                      url: "../servlet/TipoUsuarioServlet?accion=crearTipoUsuario",
                                      dataType: 'JSON',
                                      data: json,
                                      success: function (data) {
                                         if (data === 1) {
                                            bootbox.dialog({
                                               className: "dialogExtraSmall",
                                               title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
                                               headerClass: "modal-bg-success",
                                               message: "Tipo de Usuario correctamente creado",
                                               buttons: {
                                                  si: {
                                                     label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                                     className: "btn-success",
                                                     callback: function () {
                                                        refrescar();
                                                     }
                                                  }
                                               }
                                            });
                                         } else {
                                            bootbox.dialog({
                                               title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                                               headerClass: "modal-bg-warning",
                                               message: "Ha ocurrido un error",
                                               buttons: {
                                                  si: {
                                                     label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                                     className: "btn-warning",
                                                     callback: function () {
                                                        refrescar();
                                                     }
                                                  }
                                               }
                                            });
                                         }
                                      }
                                   });
                                   refrescar();
                                } else {
                                   bootbox.dialog({
                                      className: "dialogExtraSmall",
                                      title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                                      headerClass: "modal-bg-warning",
                                      message: "El nombre ingresado está en uso",
                                      buttons: {
                                         si: {
                                            label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                            className: "btn-warning",
                                            callback: function () {
                                               $('#btnNuevoTipoUsuario').click();
                                            }
                                         }
                                      }
                                   });
                                }
                             });
                  } else {
                     return false;
                  }
               }
            },
            cancel: {
               label: "<i class='fa fa-times bigger-110'></i>&nbsp; Cancelar",
               className: "btn-danger",
               callback: function () {
               }
            }
         }
      });
      nuevoTipoUsuario.init(function () {
         new Input({el: '#crearNombre', param: 'alphanumeric'}).validate();
         submitKey('formCrearTipoUsuario', '.buttonOk');
      });
   });

   function activarTipoUsuario() {
      $('#tblTipoUsuario tbody').on('click', '.activar', function () {
         var table = $("#tblTipoUsuario").DataTable();
         var data = table.row($(this).parents('tr')).data();
         var codigo = data["codigoTipoUsuario"];
         var json = {
            "codigo": codigo
         };
         $.ajax({
            type: 'POST',
            url: "../servlet/TipoUsuarioServlet?accion=activarTipoUsuario",
            dataType: 'JSON',
            data: json,
            success: function (data) {
               if (data === 1) {
                  bootbox.dialog({
                     className: "dialogExtraSmall",
                     title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
                     headerClass: "modal-bg-success",
                     message: "Estado correctamente modificado",
                     buttons: {
                        si: {
                           label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                           className: "btn-success",
                           callback: function () {
                              refrescar();
                           }
                        }
                     }
                  });
               } else {
                  bootbox.dialog({
                     title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                     headerClass: "modal-bg-warning",
                     message: "Ha ocurrido un error",
                     buttons: {
                        si: {
                           label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                           className: "btn-warning",
                           callback: function () {
                           }
                        }
                     }
                  });
               }
            }
         });
      });
   }

   function desactivarTipoUsuario() {
      $('#tblTipoUsuario tbody').on('click', '.desactivar', function () {
         var table = $("#tblTipoUsuario").DataTable();
         var data = table.row($(this).parents('tr')).data();
         var codigo = data["codigoTipoUsuario"];
         var json = {
            "codigo": codigo
         };
         validarTipoUsuario(codigo)
                 .then((data) => {
                    if (data === 0) {
                       $.ajax({
                          type: 'POST',
                          url: "../servlet/TipoUsuarioServlet?accion=desactivarTipoUsuario",
                          dataType: 'JSON',
                          data: json,
                          success: function (data) {
                             if (data === 1) {
                                bootbox.dialog({
                                   className: "dialogExtraSmall",
                                   title: "<i class='ace-icon fa fa-tags white'></i> <span class='white'>Notificación</span>",
                                   headerClass: "modal-bg-success",
                                   message: "Estado correctamente modificado",
                                   buttons: {
                                      si: {
                                         label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                         className: "btn-success",
                                         callback: function () {
                                            refrescar();
                                         }
                                      }
                                   }
                                });
                             } else {
                                bootbox.dialog({
                                   className: "dialogExtraSmall",
                                   title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                                   headerClass: "modal-bg-warning",
                                   message: "Ha ocurrido un error",
                                   buttons: {
                                      si: {
                                         label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                         className: "btn-warning",
                                         callback: function () {
                                            refrescar();
                                         }
                                      }
                                   }
                                });
                             }
                          }
                       });
                    } else {
                       bootbox.dialog({
                          className: "dialogExtraSmall",
                          title: "<i class='ace-icon fa fa-exclamation-circle white'></i> <span class='white'>Advertencia</span>",
                          headerClass: "modal-bg-warning",
                          message: "El tipo de usuario seleccionado está en uso",
                          buttons: {
                             si: {
                                label: "<i class='fa fa-check bigger-110'></i>&nbsp; OK",
                                className: "btn-warning",
                                callback: function () {
                                }
                             }
                          }
                       });
                    }
                 });
      });
   }

   function validarTipoUsuario(codigo) {
      let json = {
         codigo: codigo
      };
      return new Promise((resolve, reject) => {
         $.ajax({
            type: 'POST',
            url: "../servlet/TipoUsuarioServlet?accion=validarTipoUsuario",
            dataType: 'json',
            data: json,
            success: function (data, textStatus, jqXHR) {
               resolve(data);
            }, error: function (jqXHR, textStatus, errorThrown) {
               reject("Error al validar tipo de usuario");
            }
         });
      });
   }

   function validarNombreTipoUsuario(nombreIngreso, nombreInicial, tipo) {
      let json = {
         nombreIngreso: nombreIngreso,
         nombreInicial: nombreInicial,
         tipo: tipo
      };
      return new Promise((resolve, reject) => {
         $.ajax({
            type: 'POST',
            url: "../servlet/TipoUsuarioServlet?accion=validarNombreTipoUsuario",
            dataType: 'json',
            data: json,
            success: function (data, textStatus, jqXHR) {
               resolve(data);
            }, error: function (jqXHR, textStatus, errorThrown) {
               reject("Error al validar nombre tipo de usuario");
            }
         });
      });
   }

