/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moduloSeguridad.services;

import moduloSeguridad.dao.DAOFactory;
import moduloSeguridad.dao.TipoUsuarioDAO;
import org.json.JSONObject;

/**
 *
 * @author sistem17user
 */
public class TipoUsuarioService {

	DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.SQLSERVER);
	TipoUsuarioDAO dao = fabrica.getTipoUsuario();

	public JSONObject listarTipoUsuario(String filtro, int vstart, int vlength, String draw) {
		JSONObject obj = null;
		try {
			obj = dao.listarTipoUsuario(filtro, vstart, vlength, draw);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}

	public int desactivarTipoUsuario(int codigo) {
		int rs = 0;
		try {
			rs = dao.desactivarTipoUsuario(codigo);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rs;
	}

	public int activarTipoUsuario(int codigo) {
		int rs = 0;
		try {
			rs = dao.activarTipoUsuario(codigo);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rs;
	}

	public int editarTipoUsuario(int codigo, String nombre) {
		int rs = 0;
		try {
			rs = dao.editarTipoUsuario(codigo, nombre);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rs;
	}

	public int crearTipoUsuario(String nombre) {
		int rs = 0;
		try {
			rs = dao.crearTipoUsuario(nombre);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rs;
	}

	public int validarTipoUsuario(int codigo) {
		int cant = 0;
		try {
			cant = dao.validarTipoUsuario(codigo);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return cant;
	}

	public int validarNombreTipoUsuario(String nombreInicial, String nombreIngreso, int tipo) {
		int cant = 0;
		try {
			cant = dao.validarNombreTipoUsuario(nombreInicial, nombreIngreso, tipo);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return cant;
	}

};
