/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moduloSeguridad.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import moduloSeguridad.services.TipoUsuarioService;
import org.json.JSONObject;

/**
 *
 * @author sistem17user
 */
public class TipoUsuarioServlet extends HttpServlet {

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		String accion = request.getParameter("accion");
		switch (accion) {
			case "listarTipoUsuario":
				listarTipoUsuario(request, response);
				break;
			case "activarTipoUsuario":
				activarTipoUsuario(request, response);
				break;
			case "desactivarTipoUsuario":
				desactivarTipoUsuario(request, response);
				break;
			case "editarTipoUsuario":
				editarTipoUsuario(request, response);
				break;
			case "crearTipoUsuario":
				crearTipoUsuario(request, response);
				break;
			case "validarTipoUsuario":
				validarTipoUsuario(request, response);
				break;
			case "validarNombreTipoUsuario":
				validarNombreTipoUsuario(request, response);
				break;
			default:
				break;
		}
	}

	private void listarTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		String filtro = request.getParameter("filtro");
		String draw = request.getParameter("draw");
		int vstart = Integer.parseInt(request.getParameter("start"));
		int vlength = Integer.parseInt(request.getParameter("length"));
		JSONObject json = service.listarTipoUsuario(filtro, vstart, vlength, draw);
		out.println(json);
	}

	private void activarTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		int codigo = Integer.parseInt(request.getParameter("codigo"));
		int rs = service.activarTipoUsuario(codigo);
		out.println(rs);
	}

	private void desactivarTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		int codigo = Integer.parseInt(request.getParameter("codigo"));
		int rs = service.desactivarTipoUsuario(codigo);
		out.println(rs);
	}

	private void editarTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		int codigo = Integer.parseInt(request.getParameter("codigo"));
		String nombre = request.getParameter("nombre");
		int rs = service.editarTipoUsuario(codigo, nombre);
		out.println(rs);
	}

	private void crearTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		String nombre = request.getParameter("nombre");
		int rs = service.crearTipoUsuario(nombre);
		out.println(rs);
	}

	private void validarTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		int codigo = Integer.parseInt(request.getParameter("codigo"));
		int rs = service.validarTipoUsuario(codigo);
		out.print(rs);
	}

	private void validarNombreTipoUsuario(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		TipoUsuarioService service = new TipoUsuarioService();
		String nombreIngreso = request.getParameter("nombreIngreso");
		String nombreInicial = request.getParameter("nombreInicial");
		int tipo = Integer.parseInt(request.getParameter("tipo"));
		int rs = service.validarNombreTipoUsuario(nombreInicial, nombreIngreso, tipo);
		out.print(rs);
	}

}
