/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moduloSeguridad.sqlserverdao;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import moduloSeguridad.utilities.GeneralMethods;
//import static moduloSeguridad.utilities.GeneralMethods.getMaxSize;
import moduloSeguridad.dao.TipoUsuarioDAO;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author sistem17user
 */
public class TipoUsuarioSqlServerDAO implements TipoUsuarioDAO {

	@Override
	public JSONObject listarTipoUsuario(String filtro, int vstart, int vlength, String draw) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		String query = "";
		String busqueda = "";
		JSONObject jsonReturn = new JSONObject();
		JSONArray lista = new JSONArray();
		int conta = vstart;
		try {
			if (filtro.equals("")) {
				busqueda = "";
			} else {
				busqueda = " and nom like '%" + filtro + "%'";
			}
			query = " select TOP " + vlength + " cod_tipo_usuario, nom, est from tipo_usuario "
				+ " where cod_tipo_usuario NOT IN"
				+ "( "
				+ " SELECT top " + vstart + " "
				+ " cod_tipo_usuario from tipo_usuario ORDER BY cod_tipo_usuario     ) "
				+ " " + busqueda + " ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeQuery();
			while (rs.next()) {
				conta++;
				JSONObject obj = new JSONObject();
				obj.put("numeral", conta);
				obj.put("codigoTipoUsuario", rs.getString(1));
				obj.put("nombreTipoUsuario", rs.getString(2));
				obj.put("estadoTipoUsuario", rs.getInt(3));
				lista.put(obj);
			}
			int cantRegistro = 0;
			String query2 = " select count(*) as cant "
				+ " from tipo_usuario "
				+ " where 1 = 1 "
				+ " " + busqueda + " ";
			PreparedStatement pst2 = null;
			ResultSet rs2 = null;
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query2);
			rs = pst.executeQuery();
			rs.next();
			cantRegistro = rs.getInt("cant");

			jsonReturn.put("data", lista);
			jsonReturn.put("recordsTotal", cantRegistro);
			jsonReturn.put("recordsFiltered", cantRegistro);
			jsonReturn.put("draw", draw);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return jsonReturn;
	}

	@Override
	public int activarTipoUsuario(int codigo) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		int rs = 0;
		String query = "";
		try {
			query = " update tipo_usuario "
				+ " set est = 1"
				+ " where cod_tipo_usuario = " + codigo + " ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return rs;
	}

	@Override
	public int desactivarTipoUsuario(int codigo) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		int rs = 0;
		String query = "";
		try {
			query = " update tipo_usuario "
				+ " set est = 0"
				+ " where cod_tipo_usuario = " + codigo + " ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return rs;
	}

	@Override
	public int editarTipoUsuario(int codigo, String nombre) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		int rs = 0;
		String query = "";
		try {
			query = " update tipo_usuario "
				+ " set nom = '" + nombre + "'"
				+ " where cod_tipo_usuario = " + codigo + " ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return rs;
	}

	@Override
	public int crearTipoUsuario(String nombre) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		int rs = 0;
		String query = "";
		try {
//	    DatabaseMetaData metadata = con.getMetaData();
//	    ResultSet rst = metadata.getColumns(null, null, "titulo", "nom");
			query = " insert into tipo_usuario (nom, est)"
				+ " values ('" + nombre + "', 1) ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return rs;
	}

	@Override
	public int validarTipoUsuario(int codigo) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		int cant = 0;
		String query = "";
		try {
			query = " select count(*) as cant from tipo_usuario as tu "
				+ " inner join proyecto_detalle as pd "
				+ " on pd.cod_tipo_usuario = tu.cod_tipo_usuario "
				+ " inner join proyecto as p "
				+ " on p.cod_proyecto = pd.cod_proyecto "
				+ " where tu.cod_tipo_usuario = " + codigo + " "
				+ " and p.est = 1 ";
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeQuery();
			rs.next();
			cant = rs.getInt("cant");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			con.close();
			pst.close();
		}
		return cant;
	}

	@Override
	public int validarNombreTipoUsuario(String nombreInicial, String nombreIngreso, int tipo) throws Exception {
		String base = "security";
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		int cant = 0;
		String query = "";
		try {
			query = " select COUNT(*) as cant from tipo_usuario "
				+ " where UPPER(nom) = UPPER('" + nombreIngreso + "') "
				+ " and est = 1 ";
			if (tipo == 1) {
				query += " and nom != '" + nombreInicial + "' ";
			}
			con = SqlServerDAOFactory.getConnectionSQL(base);
			pst = con.prepareStatement(query);
			rs = pst.executeQuery();
			rs.next();
			cant = rs.getInt("cant");
		} catch (Exception e) {
			e.printStackTrace();
			cant = 2;
		} finally {
			con.close();
			pst.close();
		}
		return cant;
	}
}
